// BtChatClient.java

import ch.aplu.gidlet.*;
import java.io.*;
import ch.aplu.bluetooth.*;
import javax.microedition.lcdui.*;

public class BtChatClient
{

// --------------- Inner class Executor ----------------
private class Executor extends Thread
{
  public void run()
  {
    isr = new InputStreamReader(bc.getInputStream());
    osw = new OutputStreamWriter(bc.getOutputStream());

    try
    {
      while (true)
      {
        int ch;
        String line = "";
        while ((ch = isr.read()) != -1)
        {
          line += (char)ch;
          if (ch == '\n')
          {
            say(line);
            line = "";
          }
        }
        // Server connection closed
        disconnect();
        bcg.startServer();
      }
    }
    catch (IOException ex)
    {
      // bc.disconnect() called
    }
    if (isVerbose)
      VerboseWriter.out.println("Executor terminated");
  }
}
// --------------- End of inner class ------------------

  private String serverName;
  private final String serviceName = "ChatServer";
  private final boolean isVerbose = false;

  private BtChatGidlet bcg;
  private BluetoothClient bc;
  private InputStreamReader isr;
  private OutputStreamWriter osw;
  private MForm form;
  private TextField tf;
  public TextArea ta;

  public BtChatClient(BtChatGidlet bcg, String serverName)
  {
    this.bcg = bcg;
    this.serverName = serverName;
    if (isVerbose)
      VerboseWriter.init("e:/debug/BtChatClient.txt");
    form = new MForm("BtChat Client");
    tf = form.addInputField("Enter line to send:", "");
    ta = new TextArea("Response:", 5, 20);
    form.append(ta);
    form.addOkButton();
    form.show();
  }

  public boolean connect()
  {
    say("Connecting to '" + serverName + "'..");
    bc = new BluetoothClient(serverName, serviceName);
    bc.setVerbose(isVerbose);
    if (!bc.connect())
    {
      VerboseWriter.close();
      return false;
    }
    new Executor().start();
    VerboseWriter.close();
    return true;
  }

  public void sendLine()
  {
    String line = tf.getString();
    tf.setString("");
    try
    {
      osw.write(line, 0, line.length());
      osw.write('\r');
      osw.write('\n');
      osw.flush();
    }
    catch (Exception ex)
    {
      // osw may be null
    }
  }

  public void say(String line)
  {
    ta.append(line);
  }

  public void disconnect()
  {
    if (bc != null)
      bc.disconnect();
  }
}
