// BtChatGidlet.java


import javax.microedition.lcdui.*;
import ch.aplu.gidlet.*;
import ch.aplu.bluetooth.*;

public class BtChatGidlet extends Gidlet
{

// ------------- Inner class MyCommandListener -------------
private class MyCommandListener implements CommandListener
{
  public void commandAction(Command c, Displayable d)
  {
    if (c == serverCommand)
    {
      isServer = true;
      wakeUp();
    }

    if (c == okCommand)
    {
      btName = askForm.getText(tf);
      if (btName.trim().length() != 0)
      {
        StringStore store = new StringStore("chatstore");
        store.write(btName);
        wakeUp();
      }
      else
        si.setText("Illegal entry");
    }
  }
}
// ------------- End of inner class ------------------------

  private BtChatClient bcc = null;
  private BtChatServer bcs = null;
  private String btName;
  private MForm askForm;
  private StringItem si;
  private TextField tf;
  private Command okCommand = new Command("OK", Command.OK, 1);
  private Command serverCommand =
    new Command("Server", Command.EXIT, 1);
  private boolean isServer = false;

  public void main()
  {
    askBtName();
    if (isServer)
      startServer();
    else
    {
      bcc = new BtChatClient(this, btName);
      if (!bcc.connect())
      {
        bcc = null;
        startServer();
      }
      else
        bcc.say("Connected");
    }
  }

  public void doOk()
  {
    if (bcc != null)
      bcc.sendLine();
    if (bcs != null)
      bcs.sendLine();
  }

  public void doExit()
  {
    if (bcc != null)
      bcc.disconnect();
    if (bcs != null)
    {
      bcs.close();
      bcs.cancel();
    }
    VerboseWriter.close();
    super.doExit();
  }

  public void startServer()
  {
    bcs = new BtChatServer();
  }

  private void askBtName()
  {
    String prompt = "Enter Bluetooth Name";
    String title = "BtChat (www.aplu.ch)";
    askForm = new MForm(title);
    askForm.addCommand(okCommand);
    askForm.removeExitButton();
    askForm.addCommand(serverCommand);
    askForm.setCommandListener(new MyCommandListener());
    tf = askForm.addInputField(prompt, "");
    si = askForm.addOutputField();
    StringStore store = new StringStore("chatstore");
    String content = store.read();
    if (content != null)
      tf.setString(content);
    askForm.show();
    putSleep();
  }
}
