// BtServer.java
// Data exchange with BtClient.java

import java.io.*;
import javax.bluetooth.*;
import ch.aplu.bluetooth.*;
import ch.aplu.gidlet.*;

public class BtServer extends Gidlet implements BtListener
{
  private BluetoothServer bs;
  private int nbConnections = 0;
  private MConsole c = new MConsole();
  private boolean isQuitting = false;

  public void main()
  {
    bs = new BluetoothServer("BtServer", this, false);
    c.println("OK to stop server");
    c.println("Wait for connection");
    waitOk();  // Block until OK is clicked
    isQuitting = true;
    bs.close();  // Announce termination to client
    bs.cancel(); // No more client to wait for
    c.println("Server dead");
  }

  public void notifyConnection(RemoteDevice rd,
                               InputStream is, OutputStream os)
  {
    nbConnections++;
    c.println("# calls: " + nbConnections);
    try
    {
      c.println("Connection established.");
      c.println("Name: " + rd.getFriendlyName(false));
      c.println("Address " + rd.getBluetoothAddress());
    }
    catch (IOException ex)
    {
      c.println("Got exception\nwhile retrieving client info");
      return;
    }

    // Retrieve streams
    DataInputStream dis = new DataInputStream(is);
    DataOutputStream dos = new DataOutputStream(os);

    try
    {
      while (true)
      {
        // Wait for data
        int n = dis.readInt();
        c.println("Got: " + n);
        delay(1000);  // Sleep a while to simulate hard work

        // Reply inverse
        dos.writeInt(-n);
        dos.flush();  // Don't forget to flush
      }
    }
    catch (IOException ex)
    {
      bs.close();
    }
      c.println("Transfer finished");
      if (!isQuitting)
        c.println("Waiting next connection");
  }
}


