// DragonGidlet.java

import ch.aplu.gidlet.Gidlet;
import ch.aplu.gidlet.Turtle;

public class DragonGidlet extends Gidlet
{
  private Turtle t = new Turtle(false);
  final private int nbGenerations = 17;

  public void main()
  {
    t.getPlayground().removeOkButton();
    t.enableRepaint(false);
    t.right(90).setPos(-100, 100);
    figure(250, nbGenerations, true);
  }

  private void figure(double length, int n, boolean inverse)
  {
    if (isExiting())
      return;
    if (n == 0)
    {
      t.forward(length);
      t.repaint();
    }
    else
    {
      int alpha = 45;
      if (inverse)
      {
        alpha = -alpha;
        inverse = !inverse;
      }
      t.left(alpha);
      figure(length / Math.sqrt(2), n - 1, !inverse);
      t.right(2 * alpha);
      figure(length / Math.sqrt(2), n - 1, inverse);
      t.left(alpha);
    }
  }
}
