// FarnGidlet.java

import ch.aplu.gidlet.*;
import java.util.Random;
import javax.microedition.lcdui.*;

public class FarnGidlet extends Gidlet
{
  private MPanel p = new MPanel(false);
  private int it, nb;

  public void main()
  {
    Random rnd = new Random();
    while (!isExiting())
    {
      nb = readInt("Wieviele Iterationen?", 20000);
      p.bgColor(BLACK);
      p.color(WHITE);
      p.window( -3.5, 3.5, 0, 10 );
      p.show(true);  // Wait until visible, so we see start of simulation
      Complex z = new Complex(0, 0);
      it = 0;

      while (it <= nb && !isExiting())
      {
        if (it % 1000 == 0)
        {
          p.color(WHITE);
          p._label("  Iterationen: " + it, 10);
        }
        double r = rnd.nextDouble();
        int color = 0;

        if (r < 0.01)
        {
          color = ORANGE;
          z = f(z, 0, 0, 0, 0.16, 0, 0); // Stiel
        }
        else
        {
          if (r < 0.86)
          {
            color = GREEN;
            z = f(z, 0.85, 0.04, -0.04, 0.85, 0, 1.60); // symmetry
          }
          else
          {
            if (r > 0.86 && r < 0.93)
            {
              color = RED;
               z = f(z, 0.20, -0.26, 0.23, 0.22, 0, 1.60); // left leaves
            }
            else
            {
              if (r > 0.93)
              {
                color = BLUE;
                z = f(z, -0.15, 0.28, 0.26, 0.24, 0, 1.44); // right leaves
              }
            }
          }
        }
        p.color(color);
        p.point(z.real, z.img);
        it++;
      }

      p.color(WHITE);
      p._rectangle(2, 2, p._displayWidth()-4, p._displayHeight()-4);
      p._label("  OK fuer naechsten Lauf", 10);

      waitOk();
    }
  }

  public void doOk()
  {
    it = nb;  // Stop animation
  }

  private Complex f(Complex z,
                    double a, double b, double c, double d, double e, double f )
  {
    double re = a*z.real + b*z.img + e;
    double im = c*z.real + d*z.img + f;
    return new Complex(re, im);
  }
}
