// FileStreamGidlet.java

import ch.aplu.gidlet.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import java.io.*;

public class FileStreamGidlet extends Gidlet
{
  private final String path = "root1/Gidlet/foo.dat";
  private MConsole c = new MConsole();

  public void main()
  {
    MFile mf = new MFile(path);
    if (mf.exists())
    {
      c.println("File\n" + path +
                "\found. Clearing it...");
      mf.clear();
    }

    c.println("Creating file\n" + path);
    mf.createFile();

    c.println("Writing integer data...");
    DataOutputStream dos = mf.getDataOutputStream();
    try
    {
      for (int i = 0; i < 10; i++)
        dos.writeInt(i);
    }
    catch (IOException ex)
    {
      c.println("Write failed");
      return;
    }
    mf.releaseConnection();
    c.println("OK");

    c.println("Reading back...");
    DataInputStream dis = mf.getDataInputStream();
    try
    {
      while (true)
        c.print(" " + dis.readInt());
    }
    catch (EOFException ex)
    {
      mf.releaseConnection();
      c.println("\nAll done");
    }
    catch (IOException ex)
    {
      c.println("\nRead failed");
      return;
    }
  }
}

