// PlayAudioGidlet.java
// Keep in mind that it takes some time to load a big
// wav file from the internet. On real device it may
// cost you a lot of money!

import ch.aplu.gidlet.*;

public class PlayAudioGidlet extends Gidlet
{
  private MList list;
  private AudioPlayer ap = null;
  private final String uri =
    "http://www.aplu.ch/g/b.wav";

  public void main()
  {
    setDebug(true);
    list = new MList("AudioPlayer");
    list.setTitle("Loading. Please wait...");
    list.show();
    ap = new AudioPlayer(uri);
    if (ap.getPlayer() == null)
    {
      showMessage(
        "Access to the internet denied", false);
      return;
    }

    list.append("Start", null);
    list.append("Pause", null);
    list.append("Stop", null);
    list.setTitle("Ready");

    while (true)
    {
      waitOk();
      int index = list.getSelectedIndex();
      switch (index)
      {
        case 0:
          ap.start();
          list.setTitle("Playing...");
          break;
        case 1:
          ap.pause();
          list.setTitle("Pausing...");
          break;
        case 2:
          ap.stop();
          list.setTitle("Stopped");
          break;
      }
    }
  }

  public void doExit()
  {
    if (ap == null)
      return;
    ap.close();
    super.doExit();
  }

  public void notifyPlayerUpdate(String event, Object eventData)
  {
    if (event.equals("readyToStart"))
      list.setTitle("Ready to start");
    if (event.equals("endOfMedia"))
      list.setTitle("Finished");
  }
}