// StateGidlet.java

import javax.microedition.lcdui.*;
import ch.aplu.gidlet.*;


public class StateGidlet extends Gidlet
{
// ------------- Simulation of enum type -------------------
interface State
{
  int STARTED  = 0;
  int STOPPED  = 1;
  int EXITING = 2;
}

// ------------- Inner class MyCommandListener -------------
private class MyCommandListener implements CommandListener
{
  public void commandAction(Command c, Displayable d)
  {
    if (c == exitCommand)
    {
      state = State.EXITING;
      wakeUp();
      notifyDestroyed();
    }
    if (c == startCommand)
    {
      state = State.STARTED;
      wakeUp();
    }
    if (c == stopCommand)
      state = State.STOPPED;
  }
}

  private Command exitCommand = new Command("Exit", Command.EXIT, 1);
  private Command startCommand = new Command("Start", Command.OK, 1);
  private Command stopCommand =  new Command("Stop",  Command.OK, 1);

  private int state = State.STOPPED;

  public void main()
  {
    Turtle t = new Turtle();
    Playground pg = t.getPlayground();
    pg.removeExitButton();
    pg.addCommand(exitCommand);
    pg.setCommandListener(new MyCommandListener());

    // Event loop
    while (state != State.EXITING)
    {
      switch(state)
      {
        case State.STOPPED:
          pg.removeCommand(stopCommand);
          pg.addCommand(startCommand);
          putSleep();
          if (state == State.EXITING)
           return;

          pg.removeCommand(startCommand);
          pg.addCommand(stopCommand);
          break;

        case State.STARTED:
          t.forward(10).left(10);
          break;
      }
    }
  }
}


