// NxtTouchGidlet.java
// Touch sensor with gear

import ch.aplu.gidlet.*;
import ch.aplu.nxt.*;

public class NxtTouchGidlet extends Gidlet
  implements TouchListener
{
  private NxtRobot robot;
  private Gear gear;

  public void main()
  {
    // Create robot and connect it
    robot = new NxtRobot();

    // Create touch sensor and assemble it
    TouchSensor ts = new TouchSensor();
    robot.addPart(ts);

    // Register listener
    ts.addTouchListener(this);

    // Create gear and assemble it
    gear = new Gear();
    robot.addPart(gear);

    // Perform task
    gear.setSpeed(30);
    gear.forward();
  }

  // Event callback method
  public void pressed(SensorPort port)
  {
    gear.backward(2000);
    gear.left(500);
    gear.forward();
  }

  // Event callback method
  public void released(SensorPort port)
  {}

  // Callback when Exit button is hit
  public void doExit()
  {
    robot.exit();
  }
}
