// RemoteControl.java

import javax.microedition.lcdui.*;
import ch.aplu.gidlet.*;
import ch.aplu.nxt.*;

public class RemoteControl extends Gidlet
{
  private NxtRobot robot;
  private MPanel p;
  private Gear gear = new Gear();
  private int speed = 0; // -100..100
  private int steeringAngle = 0; // -10..10

  public void main()
  {
    robot = new NxtRobot(null, false);
    if (!robot.connect())
      return;
    robot.addPart(gear);

    p = new MPanel("NXT Control", 0, 100, 0, 100);
    p.show();
    p.bgColor(BLUE);
    p.color(WHITE);
    p.addKeyListener(this);
    p._label(" Cursor keys to navigate", 70);
    p._label(" Fire to go ahead", 90);
    p._label(" Rev to reverse", 110);
    p.addOkButton("Rev");
  }

  public void keyPressed(int keyCode)
  {
    keyRepeated(keyCode);
  }

  public void keyRepeated(int keyCode)
  {
    int sStep = 4;
    int aStep = 1;
    boolean ok = false;
    switch (p.getGameAction(keyCode))
    {
      case Canvas.FIRE:
        steeringAngle = 0;
        ok = true;
        break;

      case Canvas.UP:
        speed += sStep;
        if (speed > 100)
          speed = 100;   // Limit
        ok = true;
        break;

      case Canvas.DOWN:
        speed -= sStep;
        if (speed < -100)
          speed = -100;  // Limit
        ok = true;
        break;

      case Canvas.LEFT:
        steeringAngle += aStep;
        if (steeringAngle > 10)
          steeringAngle = 10;   // Limit
        ok = true;
        break;

      case Canvas.RIGHT:
        steeringAngle -= aStep;
        if (steeringAngle < -10)
          steeringAngle = -10;  // Limit
        ok = true;
        break;
    }
    if (ok)
      setMotion();
  }

  private void setMotion()
  {
    gear.setSpeed(Math.abs(speed));
    if (speed >= 0)  // forward
    {
      if (steeringAngle > 1)
        gear.leftArc(1.0 / Math.abs(steeringAngle));
      else
      {
        if (steeringAngle < -1)
          gear.rightArc(1.0 / Math.abs(steeringAngle));
        else
          gear.forward();
      }
    }
    else  // backward
    {
      if (steeringAngle > 1)
        gear.leftArc(-1.0 / Math.abs(steeringAngle));
      else
      {
        if (steeringAngle < -1)
          gear.rightArc(-1.0 / Math.abs(steeringAngle));
        else
          gear.backward();
      }
    }
  }

  public void doOk()
  {
    speed = -speed;
    setMotion();
  }

  public void doExit()
  {
    robot.disconnect();
    notifyDestroyed();
  }
}
