// KeyListener.java

/*
  This software is part of the Gidlet framework.
  It is Open Source Free Software, so you may
    - run the code for any purpose
    - study how the code works and adapt it to your needs
    - integrate all or parts of the code in your own programs
    - redistribute copies of the code
    - improve the code and release your improvements to the public
  However the use of the code is entirely your responsibility.
 */

package ch.aplu.gidlet;

/**
 * Interface for key event callback methods.<br>
 * To get a key callback, implement one of them and register your class
 * with MPanel.addKeyListener().<br>
 * class Gidlet implements a empty declaration of these methods.
 */
public interface KeyListener
{
  /**
   * Called when a key is pressed.
   */
  public void keyPressed(int keyCode);

  /**
   * Called when a key is released.
   */
  public void keyReleased(int keyCode);

  /**
   * Called when a key is repeated (held down).
   */
  public void keyRepeated(int keyCode);
}