// DebugConsole.java, Java ME version
// Platform (Java SE, ME) dependent code
// Should be visible in package only. Not included in Javadoc

/*
This software is part of the NxtJLib library.
It is Open Source Free Software, so you may
- run the code for any purpose
- study how the code works and adapt it to your needs
- integrate all or parts of the code in your own programs
- redistribute copies of the code
- improve the code and release your improvements to the public
However the use of the code is entirely your responsibility.
 */

package ch.aplu.nxt.platform;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import ch.aplu.gidlet.*;
import ch.aplu.nxt.*;

public class DebugConsole
{
  private static MConsole c = null;
  private static Displayable previousDisplay = null;
  private static Displayable myDisplay =  null;
  private Command okCommand = new Command("OK", Command.OK, 1);

  // ------------- Inner class MyCommandListener -------------
  private class MyCommandListener implements CommandListener
  {
    public void commandAction(Command c, Displayable d)
    {
      if (c == okCommand && previousDisplay != null)
        Gidlet.display.setCurrent(previousDisplay);
    }
  }

  private DebugConsole()
  {
    c = new MConsole(0, Gidlet.BLACK, Gidlet.WHITE, 1);
    c.removeExitButton();
    c.addCommand(okCommand);
    c.setCommandListener(new MyCommandListener());
    c.println("Debug Console");
    c.println("OK for previous display");
    myDisplay = Gidlet.display.getCurrent();
  }

  public static void showTimed(String msg, int displayTime)
  {
    Displayable currentDisplay = Gidlet.display.getCurrent();
    if (currentDisplay != myDisplay)
      previousDisplay = currentDisplay;
    if (c == null)
      new DebugConsole();
    c.println(msg);
    c.show();
    if (displayTime > 0)
    {
      Tools.delay(displayTime);
      Gidlet.display.setCurrent(currentDisplay);
    }
  }

  public static void show(String msg)
  {
    showTimed(msg, 0);
  }
}
