// NxtThread.java, Java ME version
// Platform (Java SE, ME) dependent code
// Should be visible in package only. Not included in Javadoc
// Dummy class in J2SE. Simulates join(int millis) in J2ME.

/*
This software is part of the NxtJLib library.
It is Open Source Free Software, so you may
- run the code for any purpose
- study how the code works and adapt it to your needs
- integrate all or parts of the code in your own programs
- redistribute copies of the code
- improve the code and release your improvements to the public
However the use of the code is entirely your responsibility.
 */

package ch.aplu.nxt.platform;

import ch.aplu.nxt.Tools;

public class NxtThread extends Thread
{
 private class InterruptThread extends Thread
 {
   private Thread t;
   private long duration;

   private InterruptThread(Thread t, long duration)
   {
     this.t = t;
     this.duration = duration;
   }

   public void run()
   {
     Tools.delay(duration);
     t.interrupt();
   }
 }

 public void joinX(long millis) throws InterruptedException
 {
   Thread currentThread = Thread.currentThread();
   new InterruptThread(currentThread, millis).start();
   try
   {
     join();
   }
   catch (InterruptedException ex)
   {
     throw ex;
   }
 }
}
